<template>
  <AppModal
    name-modal="modal-location"
    :width-modal="814"
    :visible="visible"
    @before-open="onModalChanged('opening')"
    @before-close="onModalChanged('closed');$emit('before-close')"
    @opened="onModalVisible"
    init-class="modalLocation">
    <template slot="header">
      <div class="appModal-title">
        Выбор города
      </div>
      <div class="form">
        <div class="input">
          <input
            type="text"
            ref="filtrationInput"
            :disabled="loading"
            v-model="filtrationText"
            class="input-field"
            placeholder="Название">
          <span
            v-show="filtrationText"
            @click="clearFiltrationText"
            class="input-action _clear">
            <img
              svg-inline
              src="~/assets/svg/redesign/cross-bold-in-circle.svg">
          </span>
          <span
            class="input-action _search">
            <img
              svg-inline
              src="~/assets/svg/redesign/magnifer-bold.svg">
          </span>
        </div>
      </div>
    </template>
    <template slot="body">
      <!-- @todo сделать компонент/директиву для loading -->
      <div class="selectLocation">
        <div
          v-show="isShownCountries"
          class="selectLocation-item">
          <ul class="listLocations ">
            <li class="listLocations-item">
              <button
                class="listLocations-button"
                :class="{ '-active': allCountrysActiveClass }"
                @click="locationSelected()">
                <span
                  class="flag">
                  <img
                    class="flag"
                    svg-inline
                    src="~/assets/svg/redesign/earth-globe.svg">
                </span>
                <span>Все страны</span>
              </button>
            </li>

            <li
              v-for="(item, index) in countries"
              :key="index"
              class="listLocations-item">
              <img
                svg-inline
                src="~/assets/svg/redesign/button-arrow-right.svg">
              <button
                class="listLocations-button"
                :class="{ '-active': item.id === activeCountry.id }"
                @click="setActiveCountry(item)">
                <span
                  class="flag"
                  v-if="item.id">
                  <img :src="'/frontapp/flags/' + item.id + '.svg'">
                </span>
                <span>{{ item.name }}</span>
              </button>
            </li>
          </ul>
        </div>

        <div
          v-show="isShownRegions"
          class="selectLocation-item">
          <div class="selectLocation-top-mobile">
            <button
              @click="resetGeo('activeCountry')"
              class="selectLocation-button-back">
              <img
                svg-inline
                src="~/assets/svg/redesign/button-arrow-right.svg">
            </button>
            <div class="selectLocation-title">
              <span
                class="flag"
                v-if="activeCountry.id">
                <img :src="'/frontapp/flags/' + activeCountry.id + '.svg'">
              </span>
              <span class="name">{{ activeCountry.name }}</span>
            </div>
          </div>

          <ul class="listLocations _has-literal">
            <li class="listLocations-item _select-all">
              <div class="listLocations-literal"/>
              <button
                @click="locationSelected(activeCountry)"
                :class="{ '-active': allRegionsActiveClass }"
                class="listLocations-button">
                Все регионы
              </button>
            </li>

            <li
              v-for="(item, index) in activeCountry.items"
              :key="index"
              class="listLocations-item">
              <img
                svg-inline
                src="~/assets/svg/redesign/button-arrow-right.svg">
              <div class="listLocations-literal">{{ getLocationLiteral(item.name, index) }}</div>
              <button
                class="listLocations-button"
                :class="{ '-active': item.id === activeRegion.id }"
                @click="setActiveRegion(item)">
                {{ item.name }}
              </button>
            </li>
          </ul>
        </div>

        <div
          v-show="isShownCities"
          class="selectLocation-item">
          <div class="selectLocation-top-mobile">
            <button
              @click="resetGeo('activeRegion')"
              class="selectLocation-button-back">
              <img
                svg-inline
                src="~/assets/svg/redesign/button-arrow-right.svg">
            </button>
            <div class="selectLocation-title">
              <span
                class="flag"
                v-if="activeCountry.id">
                <img :src="'/frontapp/flags/' + activeCountry.id + '.svg'">
              </span>
              <span class="name">{{ activeRegion.name }}</span>
            </div>
          </div>


          <ul class="listLocations">
            <li
              class="listLocations-item">
              <button
                type="button"
                @click="locationSelected(activeRegion)"
                :class="{ '-active': allCitiesActiveClass }"
                class="listLocations-button _no-arrow">
                Все города
              </button>
            </li>

            <li
              v-for="(item, index) in activeRegion.items"
              :key="index"
              class="listLocations-item">
              <button
                class="listLocations-button _no-arrow"
                :class="{ '-active': item.id === activeCity.id }"
                @click="setActiveCity(item)">
                {{ item.name }}
              </button>
            </li>
          </ul>
        </div>
      </div>
    </template>
  </AppModal>
</template>

<script>
import { find, sortBy } from 'lodash-es';

import AppModal from '~/components/redesign/app-modals/app-modal';

import { GeoLevel } from '~/backend/api-bundle/graphql/types';
import Modals from '~/assets/js/mixins/redesign/modals';
import isMobileMixin from '~/assets/js/mixins/is-mobile';

export default {
  name: 'AppModalLocation',
  components: {
    AppModal,
  },
  mixins: [Modals, isMobileMixin],
  props: {
    location: {
      type: Object,
      default() { return {}; },
    },
  },
  data() {
    return {
      loading: false,
      city: null,
      tree: [],
      filtrationText: '',
      activeCountry: false,
      activeRegion: false,
      activeCity: false,
    };
  },
  computed: {
    countries() {
      const filterCities = cities => cities.filter(city => (
        city.name.toLowerCase().startsWith(this.filtrationText.toLowerCase())
      ));

      const filterRegions = regions => regions
        .filter(region => filterCities(region.items).length
          || region.name.toLowerCase().startsWith(this.filtrationText.toLowerCase()))
        .map(region => ({ ...region, items: filterCities(region.items) }));

      const filterCountries = countries => countries
        .filter(country => filterRegions(country.items).length
          || country.name.toLowerCase().startsWith(this.filtrationText.toLowerCase()))
        .map(country => ({ ...country, items: filterRegions(country.items) }));

      if (this.filtrationText) {
        return filterCountries(this.tree);
      }

      return this.tree;
    },
    isShownCountries() {
      if (this.isMobile() && this.activeBlockMobile !== 'country') {
        return false;
      }
      return true;
    },
    isShownRegions() {
      let shown = true;
      if (this.isMobile() && this.activeBlockMobile !== 'region') {
        shown = false;
      } else if (!this.isMobile() && !this.activeCountry) {
        shown = false;
      }
      return shown;
    },
    isShownCities() {
      let shown = true;
      if (this.isMobile() && this.activeBlockMobile !== 'city') {
        shown = false;
      } else if (!this.isMobile() && !this.activeRegion) {
        shown = false;
      }
      return shown;
    },
    activeBlockMobile() {
      let activeBlock = 'country';
      if (this.activeCountry && !this.activeRegion) {
        activeBlock = 'region';
      } else if (this.activeCountry && this.activeRegion) {
        activeBlock = 'city';
      }
      return activeBlock;
    },
    allCountrysActiveClass() {
      return !this.filtrationText
        && !this.activeCountry
        && !this.activeRegion
        && !this.activeCity;
    },
    allRegionsActiveClass() {
      return !this.filtrationText
        && !!this.activeCountry
        && !this.activeRegion
        && !this.activeCity;
    },
    allCitiesActiveClass() {
      return !this.filtrationText
        && !!this.activeCountry
        && !!this.activeRegion
        && !this.activeCity;
    },
  },
  watch: {
    filtrationText(val) {
      this.resetGeo('activeCountry');
      if (this.countries.length) {
        this.activeCountry = this.countries[0];
        this.activeRegion = this.countries[0].items[0] || false;
      }
      if (!val) {
        this.resetGeo('activeCountry');
      }
    },
  },
  methods: {
    async onModalChanged(state) {
      if (state === 'closed') {
        this.loading = false;
        this.clearFiltrationText();
        return true;
      }
      if (state === 'opening') {
        this.loading = true;
        try {
          if (!this.tree.length) {
            const [
              { data: tree },
              { data: list },
            ] = await Promise.all([
              await this.$axios.$get('/_main/geo/getTree'),
              await this.$axios.$get('/_main/geo/get'),
            ]);
            this.tree = sortBy(tree, item => (item.id === '390' ? 0 : 1)); // Россия на первом месте
            this.list = list;
          }
          if (this.location.id) {
            const location = find(this.list, { id: this.location.id }) || false;
            const activeCity = location;
            let activeRegion = location;
            let activeCountry = location;
            switch (this.location.level) {
              case GeoLevel.City:
                activeRegion = find(this.list, { id: activeCity.parentId }) || false;
                // fall through
              case GeoLevel.Area:
                activeCountry = find(this.list, { id: activeRegion.parentId }) || false;
                // fall through
              default:
            }
            this.activeCountry = find(this.tree, { id: activeCountry.id }) || false;
            this.activeRegion = find(this.activeCountry.items, { id: activeRegion.id }) || false;
            this.activeCity = find(this.activeRegion.items, { id: activeCity.id }) || false;
            // TODO: скролить к активному элементу страны, региона и города
          } else {
            this.activeCountry = false;
            this.activeRegion = false;
            this.activeCity = false;
          }
          this.$nextTick(() => {
            this.scrollToActiveElements();
          });
        } catch (e) {
          console.error(e);
        } finally {
          this.loading = false;
        }
      }
      return true;
    },
    onModalVisible() {
      try {
        if (!this.isMobile()) {
          this.$refs.filtrationInput.focus();
          this.scrollToActiveElements();
        }
      } catch (e) {
        console.log(e);
      }
    },
    scrollToActiveElements() {
      if (!this.isMobile()) {
        // скролить к активному элементу страны, региона и города
        [...document.getElementsByClassName('listLocations-button -active')]
          .forEach(item => (item.scrollIntoView()));
      }
    },

    setActiveCountry(item = false) {
      this.activeCountry = item;
      this.activeRegion = false;
    },
    setActiveRegion(item = false) {
      if (this.activeRegion === item) {
        this.activeRegion = false;
      } else {
        this.activeRegion = item;
      }
    },
    setActiveCity(item = false) {
      this.activeCity = item;
      this.locationSelected(item);
    },
    resetGeo(geo) {
      if (geo === 'activeCountry') {
        this.activeCountry = false;
        this.activeRegion = false;
        this.activeCity = false;
      }
      if (geo === 'activeRegion') {
        this.activeRegion = false;
        this.activeCity = false;
      }
    },
    getLocationLiteral(name, index) {
      const firstChar = name.charAt(0);

      if (!this.activeCountry.items.length) {
        return '';
      }

      if (index - 1 < 0) {
        return firstChar;
      }

      return firstChar !== this.activeCountry.items[index - 1].name.charAt(0)
        ? firstChar
        : '';
    },
    locationSelected(item = null) {
      if (!item) {
        this.activeCity = false;
      }
      this.$emit('location-selected', item);
    },
    clearFiltrationText() {
      this.filtrationText = '';
    },
  },
};
</script>

<style lang="postcss">
  .modalLocation {
    .appModal {
      &-header {
        padding-right: 4.125rem;

        .appModal-title {
          text-align: left;
        }

        .form {
          margin-left: auto;
          width: 66%;

          .input-field {
            padding-right: 2.5rem;
            padding-left: 2.125rem;
            height: var(--btn-height-regular);
          }

          .input-action._search {
            left: 0;
            display: flex;
            pointer-events: none;

            .svg {
              margin: auto;
              fill: var(--color-disabled);
            }
          }

          .input-action._clear {
            display: flex;

            .svg-circle {
              fill: var(--color-disabled);
              transition: fill 0.1s var(--transition-easeOutQuad);
            }

            &:hover {
              .svg-circle {
                fill: var(--fill-active);
              }
            }
          }
        }
      }

      &-body {
        display: flex;
        min-height: 26rem;
        max-height: 26rem;
        @media only screen and ( max-width: 980px ) {
          max-height: 100%;
        }
      }
    }

    .selectLocation {
      display: flex;
      padding-bottom: 2rem;
      width: 100%;
      /* max-height: 100%; */
      &-item {
        display: block;
        padding: 1rem 0.5rem 0 1.625rem;
        width: 33.333%;
        max-height: 100%;
        font-size: 0.875rem;
        border-right: 1px solid var(--bg-lighten);
        overflow-y: auto;
        transition: opacity 0.3s var(--transition-easeOutQuad);

        .link {
          cursor: pointer;
        }
      }

      &-top-mobile {
        display: none;
      }
    }

    .listLocations {
      display: block;
      margin: 0;
      padding: 0.25rem 0 0 0;
      list-style: none;

      &-item {
        > .svg {
          display: none;
        }

      }

      &-button {
        position: relative;
        display: flex;
        padding: 0.5rem 1rem 0.5rem 0.75rem;
        width: calc(100% - 0.75rem);
        font-weight: var(--font-weight-regular);
        text-align: left;
        border-radius: 0.25rem;
        border: none;
        outline: none;
        background-color: transparent;
        cursor: pointer;
        transition: background-color 0.1s var(--transition-easeOutQuad),
          font-weight 0.1s var(--transition-easeOutQuad);

        &:after {
          content: '';
          position: absolute;
          top: 0;
          bottom: 0;
          right: -0.75rem;
          width: 2.5rem;
          height: 100%;
          background-image: url("~assets/svg/redesign/arrow-bg.png");
          background-position: right center;
          background-size: 2rem 100%;
          background-repeat: no-repeat;
          opacity: 0;
          transition: opacity 0.1s var(--transition-easeOutQuad);
        }

        &:hover, &:active, &:focus, &.-active {
          background-color: var(--bg-link);

          .link {
            color: var(--color-main);
          }

          &:after {
            opacity: 1;
          }
        }

        &.-active {
          font-weight: var(--font-weight-medium);
        }

        &._no-arrow {
          width: auto;

          &:after {
            content: none;
          }
        }
      }

      &._has-literal {
        .listLocations-item {
          position: relative;
          display: flex;
        }

        .listLocations-literal {
          display: block;
          margin: 0.625rem 0 auto -0.5rem;
          width: 1.25rem;
          line-height: 1;
          color: var(--color-main-lightest);
        }

        .listLocations-button {
          width: calc(100% - 1.5rem);
        }
      }
    }

    .flag {
      display: flex;
      align-items: center;
      flex-shrink: 0;
      margin-right: 0.75rem;
      width: 1.4375rem;
      height: 0.9375rem;
      border-radius: 0.125rem;
      overflow: hidden;

      img {
        width: 103%;
        height: auto;
      }
    }


    @media screen and (max-width: 980px) {
      top: 0 !important;
      left: 0 !important;
      right: 0;
      margin: 0 auto;
      min-height: 100vh;
      .appModal {
        &-header {
          flex-direction: column;
          padding: 1.25rem 1.125rem 0.5rem 1.125rem;
          height: auto;
          border: none;

          .appModal-title {
            width: 100%;
            text-align: center;
          }

          .form {
            margin: 1.25rem 0 0 0;
            width: 100%;

            .input-field {
              padding-right: 3.25rem;
              padding-left: 0.75rem;
              height: 3.75rem;
              font-size: 1rem;
            }

            .input-action._search {
              left: auto;
              right: 0;
              pointer-events: auto;

              .svg {
                width: 1.25rem;
              }
            }

            .input-action._clear {
              display: none;
            }
          }
        }

        &-body {
          display: flex;
          padding-bottom: var(--mobile-browser-bar);
          min-height: calc(100vh - 8.625rem);
          @media only screen and ( max-width: 980px ) {
            max-height: 100%;
          }
        }
      }

      .selectLocation {
        padding-bottom: 0;
        width: 300%;

        &-item {
          display: block;
          padding: 0;
          width: 100%;
          /* max-height: calc(var(--current-vh-max) - 8.625rem); */
          font-size: 1.125rem;
          border-right: none;
          overflow-y: auto;

          > .link {
            width: 100%;
            padding: 0.25rem 1.25rem 1.25rem 1.25rem;
          }
        }

        &-title {
          position: relative;
          display: block;
          padding: 0.6rem 3rem 0.6rem 0;
          margin: 0 auto;
          font-weight: var(--font-weight-medium);
          text-align: center;
          width: 27rem;
          .flag {
            display: inline-flex;
            vertical-align: top;
            margin-top: 0.25rem;
          }

          .name {
            display: inline;
          }
        }

        &-top-mobile {
          display: flex;
          align-items: flex-start;
          width: 30rem;
        }

        &-button-back {
          display: flex;
          width: 3rem;
          padding: 1rem 0 1rem 1.25rem;
          font-size: 1.25rem;
          font-weight: var(--font-weight-medium);
          text-align: left;
          background: none;
          border: none;

          .svg {
            display: block;
            margin: 0 0.75rem auto 0;
            width: 0.4375rem;
            height: auto;
            transform: rotate(180deg);
          }
        }

      }

      .listLocations {
        padding: 0;
        background-color: var(--bg-lightest);

        &-item {
          position: relative;
          border-top: 1px solid var(--border-color-main);
          &:last-of-type {
            border-bottom: 1px solid var(--border-color-main);
          }

          > .svg {
            flex-shrink: 0;
            position: absolute;
            top: 1.25rem;
            right: 1.25rem;
            display: block;
            width: 0.4375rem;
            height: auto;
            fill: var(--color-main)
          }
        }

        &-button, &-button._no-arrow {
          padding: 1rem 2.25rem 1rem 1.25rem;
          width: 100%;
          font-size: 1rem;
          &:after {
            content: none;
          }
        }

        &._has-literal {
          .listLocations-item {
            padding-left: 1.25rem;

            &._select-all {
              margin-left: 0;
              padding-left: 0;
              .listLocations-literal {
                display: none;
              }
              .listLocations-button {
                padding-left: 3.75rem;
              }
            }
          }

          .listLocations-literal {
            margin: 0.875rem 0 auto 0;
            width: 1.25rem;
            font-size: 1.5rem;
            color: var(--color-main-lightest);
          }

          .listLocations-button {
            width: 100%;
          }
        }
      }

      .flag {
        margin-top: 0.1875rem;
      }
    }

    @media only screen and ( max-width: 480px ) {
      .selectLocation {
        &-top-mobile {
          width: 100vw;
        }

        &-title {
          width: calc(100vw - 3rem);
        }
      }
    }

  }
</style>
